<template>
    <el-form ref="userRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item :label="$t('profile-userInfo-19913656f5203f81d-1')" prop="nickName">
            <el-input v-model="form.nickName" maxlength="30" />
        </el-form-item>
        <el-form-item :label="$t('profile-userInfo-19913656f5203f81d-2')" prop="phonenumber">
            <el-input v-model="form.phonenumber" maxlength="11" />
        </el-form-item>
        <el-form-item :label="$t('profile-userInfo-19913656f5203f81d-3')" prop="email">
            <el-input v-model="form.email" maxlength="50" />
        </el-form-item>
        <el-form-item :label="$t('profile-userInfo-19913656f5203f81d-4')">
            <el-radio-group v-model="form.sex">
                <el-radio label="0">{{ $t('profile-userInfo-19913656f5203f81d-5') }}</el-radio>
                <el-radio label="1">{{ $t('profile-userInfo-19913656f5203f81d-6') }}</el-radio>
            </el-radio-group>
        </el-form-item>
        <el-form-item>
            <el-button type="primary" @click="submit">
                {{ $t('profile-userInfo-19913656f5203f81d-7') }}
            </el-button>
            <el-button type="danger" @click="close">
                {{ $t('profile-userInfo-19913656f5203f81d-8') }}
            </el-button>
        </el-form-item>
    </el-form>
</template>

<script setup>
import { updateUserProfile } from '@/api/system/user';

const t = inject('t');

const props = defineProps({
    user: {
        type: Object,
    },
});

const { proxy } = getCurrentInstance();

const form = ref({});
const rules = ref({
    nickName: [
        {
            required: true,
            message: t('profile-userInfo-19913656f5203f81d-9'),
            trigger: 'blur',
        },
    ],
    email: [
        {
            required: true,
            message: t('profile-userInfo-19913656f5203f81d-10'),
            trigger: 'blur',
        },
        {
            type: 'email',
            message: t('profile-userInfo-19913656f5203f81d-11'),
            trigger: ['blur', 'change'],
        },
    ],

    phonenumber: [
        {
            required: true,
            message: t('profile-userInfo-19913656f5203f81d-12'),
            trigger: 'blur',
        },
        {
            pattern: /^1[3|4|5|6|7|8|9][0-9]\d{8}$/,
            message: t('profile-userInfo-19913656f5203f81d-13'),
            trigger: 'blur',
        },
    ],
});

/** 提交按钮 */
function submit() {
    proxy.$refs.userRef.validate(valid => {
        if (valid) {
            updateUserProfile(form.value).then(response => {
                proxy.$modal.msgSuccess(t('profile-userInfo-19913656f5203f81d-14'));
                props.user.phonenumber = form.value.phonenumber;
                props.user.email = form.value.email;
            });
        }
    });
}

/** 关闭按钮 */
function close() {
    proxy.$tab.closePage();
}

// 回显当前登录用户信息
watch(
    () => props.user,
    user => {
        if (user) {
            form.value = {
                nickName: user.nickName,
                phonenumber: user.phonenumber,
                email: user.email,
                sex: user.sex,
            };
        }
    },
    { immediate: true }
);
</script>
